SystemOrganization addCategory: #'Limbo-Core'!
SystemOrganization addCategory: #'Limbo-Core-Exceptions'!

Exception subclass: #LimboException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core-Exceptions'

	classInstanceVariableNames:''!

Object subclass: #Limbo
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'

	classInstanceVariableNames:''!

!Limbo class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 18:55'!
run: aString arguments: aCollection
	^ self new
		run: aString arguments: aCollection;
		yourself! !

!Limbo class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 17:02'!
runSh: aString
	^ self new
		runSh: aString;
		yourself! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:47'!
command
	^ command ifNil: [ command := LimboCommand new ]! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
command: aLimboCommand
	command := aLimboCommand! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:43'!
errorString
	^ self command errorString! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:43'!
outString
	^ self command outString! !

!Limbo methodsFor: 'running' stamp: 'MML 11/14/2012 18:46'!
run: aString arguments: aCollection
	self command
		command: aString;
		arguments: aCollection;
		run! !

!Limbo methodsFor: 'running' stamp: 'MML 11/14/2012 18:32'!
runSh: aString
	self run: '/bin/sh' arguments: { '-c'. aString }! !

Object subclass: #LimboCommand
	instanceVariableNames: 'command arguments outString errorString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'

	classInstanceVariableNames:''!

!LimboCommand class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 17:15'!
command: aString arguments: aCollection
	^ self new
		command: aString;
		arguments: aCollection;
		yourself! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:12'!
arguments
	^ arguments! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:11'!
arguments: aCollection
	arguments := aCollection! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:11'!
command
	^ command! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:11'!
command: aString
	command := aString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
errorString
	^ errorString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
errorString: aString
	errorString := aString! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 18:40'!
nbLibraryNameOrHandle
	^ '/apps/cmsbox3/system/liblimbo.dylib'! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
outString
	^ outString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
outString: aString
	outString := aString! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/14/2012 18:14'!
primitiveArguments
	| bufferPointer |
	"a pointer uses 4 bytes on 32-bit systems.
	buffer is the pointer to the lowest allocated address"
	bufferPointer := NativeBoost allocate: self primitiveShellArguments size * 4.
	self primitiveCollectArgumentPointersInto: bufferPointer.
	bufferPointer freeAfterUse.
	
	 ^ bufferPointer! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/14/2012 17:29'!
primitiveBufferFrom: aPointer at: anIndex
	^ (NBExternalAddress new value: (aPointer nbUInt32AtOffset: anIndex)) readString! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/14/2012 18:30'!
primitiveCollectArgumentPointersInto: aPointer
	self primitiveShellArguments allButLast withIndexDo: [ :string :index || pointer | "0 terminated"
		pointer := NativeBoost allocate: string size + 1.
		NativeBoost memCopy: string to: pointer size: string size.
		pointer nbUInt8AtOffset: string size put: 0. "string terminating null char"
		aPointer nbUInt32AtOffset: (index - 1) * 4 put: pointer value.
		pointer freeAfterUse ].
	
	aPointer nbUInt32AtOffset: (self primitiveShellArguments size - 1) * 4 put: 0! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 17:30'!
primitiveErrorPointerIndex
	^ 4! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 17:30'!
primitiveOutPointerIndex
	^ 0! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/14/2012 18:41'!
primitiveReadStringsFrom: aPointer
	self outString: (self primitiveBufferFrom: aPointer at: self primitiveOutPointerIndex).
	self errorString: (self primitiveBufferFrom: aPointer at: self primitiveErrorPointerIndex)! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/14/2012 17:53'!
primitiveRun: aPointer
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >
	 ^ self nbCall: #( NBExternalAddress run_command (NBExternalAddress aPointer) ) ! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 18:05'!
primitiveShellArguments
	^ OrderedCollection new
		add: self command;
		addAll: self arguments;
		add: 0; "shell arguments are '\0' terminated"
		yourself! !

!LimboCommand methodsFor: 'printing' stamp: 'MML 11/14/2012 17:14'!
printCommand
	String streamContents: [ :stream |
		stream nextPutAll: self command.
		self arguments do: [ :string |
			stream 
				space;
				nextPutAll: string ] ]! !

!LimboCommand methodsFor: 'running' stamp: 'MML 11/14/2012 19:00'!
run
	| bufferPointer |
	bufferPointer := self primitiveRun: self primitiveArguments.
	bufferPointer ifNil: [ LimboException signal: 'Something went wrong when calling a NB primitive' ].
	self primitiveReadStringsFrom: bufferPointer! !
